﻿using System;
using System.Security.Cryptography;
using SafeOrbit.Memory;
using SecureData.Data;
using SecureData.Managers;
using ProtectedData = SecureData.Data.ProtectedData;

namespace SecureData
{
    class Program
    {

        static async Task Main()
        {
            string signedFile = "signed.pgp";
            SafeOrbitPGPCryptoManager pgp = new SafeOrbitPGPCryptoManager("publicKey.asc", "privateKey.asc");

            pgp.GenerateKeys("user@example.com", "MonMotDePasseUltraSecret");
  

          

            using (SafeObject<ProtectedData> safeObject = new SafeObject<ProtectedData>())
            {
                safeObject.ApplyChanges((data) => data.Password = "MonMotDePasseChiffré");
                safeObject.ApplyChanges((data) => data.Passphrase = "4UGy8Xps982H7JpXjmVM");
                pgp.SignData(safeObject,signedFile, "MonMotDePasseUltraSecret");
                    // You can alternatively use an existing instance to protect: new SafeObject(new InitialSafeObjectSettings(initialValue, true));
                    // Each change to the object's state or code must be using ApplyChanges

                
                if (pgp.VerifySignature(signedFile,safeObject))
                {
                    string encryptedFile = "password.pgp";
                    pgp.EncryptPassword(safeObject, encryptedFile);
                    string? decryptedPassword = pgp.DecryptPassword(encryptedFile, "MonMotDePasseUltraSecret");
                }

            }



         /*   string safePassword = "MonMotDePasseSuperSecret";


            
                 pgp.EncryptPassword(safePassword, encryptedFile);

                 string? decryptedPassword = pgp.DecryptPassword(encryptedFile, "MonMotDePasseUltraSecret");
                 Console.WriteLine($"✅ Mot de passe déchiffré : {decryptedPassword}");

                 using (var safeMessage = new SafeString())
                 {
                    safePassword.AppendAsync("Message Important à Signer").GetAwaiter().GetResult();


                     pgp.SignData(safeMessage, "signedMessage.pgp", "MonMotDePasseUltraSecret");
                 }
             }*/

        }
    }
}